      -------------------- Définition des variables --------------------
-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
local addonName = "GearHelper"
local version = GetAddOnMetadata(addonName, "Version")
print("Version actuelle : "..version)
local rappelVersion = false
local prefix = "GeARHeLPeRPReFIX"--..version -- rajouter version si on veut que notre addon ne comunique QUE avec les GH de la même version
-- ^ Pour le préfix, choisir un nom qu'on est sûr que personne d'autre ne réutilisera
local L = GearHelperLocalization

local allEvents = {}
local allPrefix = {
	["askVersion"..prefix] = sendAnswerVersion,
	["answerVersion"..prefix] = receiveAnswer,
}
local eventHandler, waitAnswerFrame, loadFrame = CreateFrame("Frame"), CreateFrame("Frame"), CreateFrame("Frame")
local askTime, maxWaitTime = nil, 15

-- NE PAS OUBLIER DE RAJOUTER LA VERSION PRÉCÉDENTE ICI APRÈS CHAQUE MISE A JOUR !!!!
local anciennesVersions = {"0.0", "0.1",}
-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
      ----------------- Fin de définition des variables -----------------
waitAnswerFrame:Hide()

-- Initialise la variable sur true la première fois qu'on utilise l'addon
-- Variable par perso, permet d'avoir différents profils
local function setDefault()
	GHActivated = true
end

-- fonction qui permet d'activer / désactiver l'addon
function setActivated( valeur )
	if valeur == true then
		GHActivated = true
		print(L["setOn"]) 
	elseif valeur == false then
		GHActivated = false
		print(L["setOff"])
	else
		print(L["errorSetActivatedValue"])
	end
end

-- permet de savoir si une nouvelle version est en ligne
function sendAskVersion()
	print("J'envoi une demande")
	if UnitInRaid("player") ~= nil then
		print("au raid")
		SendAddonMessage(prefix, "askVersion;"..version, "RAID")
	else
		print("pas au raid")
	end
	if IsInGuild() == true then
		print("en guilde")
		SendAddonMessage(prefix, "askVersion;"..version, "GUILD")
	else
		print("pas en guilde")
	end
	if UnitInParty("player") then
		print("au groupe")
		SendAddonMessage(prefix, "askVersion;"..version, "PARTY")
	else
		print("pas au groupe")
	end

	askTime = time()
	waitAnswerFrame:Show()
end
function sendAnswerVersion()
	print("J'envoi une réponse")
	if UnitInRaid("player") ~= nil then
		print("au raid")
		SendAddonMessage(prefix, "answerVersion;"..version, "RAID")
	else
		print("pas au raid")
	end
	if IsInGuild() then
		print("à la guilde")
		SendAddonMessage(prefix, "answerVersion;"..version, "GUILD")
	else
		print("pas à la gulde")
	end
	if UnitInParty("player") then
		print("au groupe")
		SendAddonMessage(prefix, "answerVersion;"..version, "PARTY")
	else 
		print("pas au groupe")
	end
end
local function receiveAnswer( msgV, msgC )
	if askTime then
		--local answerVersion = msgV:sub(-3)
		if not rappelVersion then
			if anciennesVersions[msgV] == nil then
				if answerVersion ~= version then
					print("Vous utilisez la version |cFFFF0000"..version.."|r de GearHelper. La version |cFF00FF00"..msgV.."|r a été trouvée chez "..msgC)
					--print(L["receiveAnswerText"])
					SendChatMessage("Vous utilisez la version |cFFFF0000"..version.."|r de GearHelper. La version |cFF00FF00"..msgV.."|r a été trouvée chez "..msgC, "WHISPER", GetUnitName("player"))
					askTime = nil
					waitAnswerFrame:Hide()
					rappelVersion = true
				end
			end
		end
	end
end
waitAnswerFrame:SetScript("OnUpdate", function ( self, elapsed )
	if askTime and (time() - askTime) > maxWaitTime then
		askTime = nil
		waitAnswerFrame:Hide()
		print("Fin de l'attente, pas de réponse !")
	end
end)

-------------------------------------------------------------------------------
-------------------------------------------------------------------------------

----------------------
-- Helper functions --				Pour ceux qui se demandent, oui, je dessine mieux en ASCII que je ne code
----------------------
--local function getCommand( command, instruction)
--	return "|cFFFF7D0A"..command.." : |r"..instruction
--end

--------------------
-- Slash commands --
--------------------
local allCommands = {
	--void = "|cFFFFFF00Tapez |cFF00FF00/gh|r|cFFFFFF00 ou |cFF00FF00/gh help|r|cFFFFFF00 pour voir l'aide|r",
	on = L["onHelpInfo"],
	off = L["offHelpInfo"],
	state = L["stateHelpInfo"],
}

local slashCmdFunc = {
	voidcommand = function ( msg )
		print("|cFFFFFF00Tapez |cFF00FF00/gh|r|cFFFFFF00 ou |cFF00FF00/gh help|r|cFFFFFF00 pour voir l'aide|r")
	end,
	on = function ( msg )
		if GHActivated == false then
			setActivated(true)
		end		
	end,
	enable = function ( msg )
		if GHActivated == false then
			setActivated(true)
		end		
	end,
	activated = function ( msg )
		if GHActivated == false then
			setActivated(true)
		end		
	end,
	off = function ( msg )
		if GHActivated == true then
			setActivated(false)
		end
	end,
	disable = function ( msg )
		if GHActivated == true then
			setActivated(false)
		end
	end,
	deactivated = function ( msg )
		if GHActivated == true then
			setActivated(false)
		end
	end,
	help = function ( msg )
		print(allCommands.on)
		print(allCommands.off)
		print(allCommands.state)
	end,
	state = function ( msg )
		if GHActivated == true then
			print("|cFF00FF00GearHelper|r |cFFFFFF00est|r|cFF0000FF activé")
		else
			print("|cFF00FF00GearHelper|r |cFFFFFF00est|r|cFFFF0000 désactivé")
		end
	end
}

-- Activation de /cmd
local cmd1 = "/gh"
local cmd2 = "/gearhelper"
SLASH_GEARHELPER1 = cmd1:lower()
SLASH_GEARHELPER2 = cmd2:lower()
-- Fin d'activation des /cmd
-- Déclaration des /cmd
SlashCmdList["GEARHELPER"] = function ( msg )
local instruction = msg:match("%a+")
if instruction then instruction = instruction:lower() end
	if msg == "" then
		slashCmdFunc["help"](msg)
	else
		if slashCmdFunc[instruction] then
			slashCmdFunc[instruction](msg)
		else
			slashCmdFunc["voidcommand"](msg)
		end
	end
end
-- Fin déclaration des /cmd

-------------------
-- Event handler --
-------------------
function allEvents:ADDON_LOADED( name )
	if name == addonName then
		-- charge le préfix de l'addon (ou un truc du genre)
		RegisterAddonMessagePrefix(prefix) 

		-- Active l'addon par défaut lors de la première connexion après l'installation
		if GHActivated == nil then
 			setDefault() 
		end

		-- Affiche à chaque connection l'état de l'addon
		if GHActivated == true then 
			print("|cFF00FF00GearHelper|r|cFF0000FF Activated|r") 
			--sendAskVersion()
		else 
			print("|cFF00FF00GearHelper|r|cFFFF0000 Deactivated|r") 
		end
	end
end
function allEvents:CHAT_MSG_ADDON( prefixMessage, message, channel, sender )

	--print("prefix :"..prefixMessage.."\nmessage : "..message.."\nchannel : "..channel.."\nsender : "..sender)
local prefVersion = message:sub(0, (message:find(";") - 1))
	if GHActivated == true then
		if prefixMessage == prefix then
				if prefVersion == "answerVersion" then
					print("answerVersion envoyé !")
				--local localPrefixSize = msg:find("F")
				--print("localPrefixSize = "..localPrefixSize)
				local vVersion = message:sub(message:find(";")+1, #message)
				print("vVersion = "..vVersion.."\nsender : "..sender)
				--if localPrefixSize then
				--	localPrefixSize = localPrefixSize - 1
				--	local msgPrefix = msg:sub(localPrefixSize + 2)
				--	if allPrefix[msgPrefix] then
				--		allPrefix[msgPrefix](RealMsg, player)
				--	end
				--end
				receiveAnswer(vVersion, sender)
			end
			if prefVersion == "askVersion" then
				print("askVersion envoyé !")
			end
		end
	end
end
function allEvents:ITEM_PUSH( bag ) -- Quand un objet attérie dans l'inventaire --bag : 0, 1, 2, 3 ou 4
	-- body
	--print(bag)
end
function allEvents:QUEST_COMPLETE() -- Quand un arrive sur la page de la quête terminée (la ou il faut choisir la récompense)
	-- body
end
function allEvents:PLAYER_ENTERING_WORLD() -- à chaque écran de chargement
	if GHActivated == true then
		sendAskVersion()
	end
end
function allEvents:START_LOOT_ROLL() -- Quand la fenêtre besoin/cupi pop
	-- body
end
function allEvents:UNIT_INVENTORY_CHANGED( slotID )
	-- print("Slot : "..slotID)
end
--------------------------------------------
-- xxxxx xxxxxxx --      -- xxxxx xxxxxxx --
--------------------------------------------

for event, _ in pairs(allEvents) do
	eventHandler:RegisterEvent(event)
end
eventHandler:SetScript("OnEvent", function ( self, event, ... )
	if GHActivated == true or GHActivated == nil then
		allEvents[event](self, ...)
	end
end)

-------------------------------------------------------------------------------
-------------------------------------------------------------------------------





--------------
-- pour chaques piece de stuff
-- faire une recherche dans l'inventaire
-- regarder s'il existe un stuff du même type
-- si oui, regarder s'il est meilleurs que celui qu'on à
-- si oui l'équiper
-- si non, le laisser dans l'inventaire


